# Reference
<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

**Classes**

* [`nvidia`](#nvidia): Installs the NVidia Drivers and CUDA.
* [`nvidia::cuda`](#nvidiacuda): Installs nvidia's CUDA driver
* [`nvidia::driver`](#nvidiadriver): Installs the NVidia Driver.  Uses the graphics-driver ppa
* [`nvidia::overclock`](#nvidiaoverclock): creates a script for overclocking the gpus.
* [`nvidia::xconfig`](#nvidiaxconfig): Configures the xserver generating xorg.conf

## Classes

### nvidia

Installs the NVidia Drivers and CUDA.

#### Parameters

The following parameters are available in the `nvidia` class.

##### `version`

Data type: `String`

The version to install.

##### `cuda_version`

Data type: `Optional[String]`

If this parmeter is set, will install cuda at the specified parameter.
@example '11-6'

Default value: `undef`

##### `basrc_file_path`

The path to the basrch file to update (uses concat).
If this parameter is set, will update the bashrc file with cuda environment variables.

##### `bashrc_file_path`

Data type: `Optional[String]`



Default value: `undef`

### nvidia::cuda

Installs nvidia's CUDA driver

#### Parameters

The following parameters are available in the `nvidia::cuda` class.

##### `version`

Data type: `String`

The version of CUDA to install.

##### `basrc_file_path`

The path to the basrch file to update (uses concat).
If this parameter is set, will update the bashrc file with cuda environment variables.

##### `bashrc_file_path`

Data type: `Optional[String]`



Default value: `undef`

### nvidia::driver

Installs the NVidia Driver.  Uses the graphics-driver ppa

#### Parameters

The following parameters are available in the `nvidia::driver` class.

##### `version`

Data type: `String`

The version to install

### nvidia::overclock

creates a script for overclocking the gpus.

#### Parameters

The following parameters are available in the `nvidia::overclock` class.

##### `user`

Data type: `String`

The user to assign ownership over the settings.

##### `user_id`

Data type: `Integer`

The id of the user to run the overclock script (requires sudo access).

##### `gpu_freq`

Data type: `Integer`

Controls the GPUGraphicsClockOffset from nvidia-settings for each GPU.

##### `power_limit`

Data type: `Integer`

Specifies maximum power limit in watts for each GPU.

##### `vram_freq`

Data type: `Integer`

Controls the GPUMemoryTransferRateOffset from nvidia-settings for each GPU.
Note, GUI tools generally double the value you see when it is set via command line, so you may need to double this setting
for the desired result.

##### `gpus`

Data type: `Integer`

The number of GPUs to control in the system.

Default value: size($::gpus_pci_ids)

##### `enable_service`

Data type: `Boolean`

Add overclock as a service to ensure overclock is called on boot.

Default value: `false`

##### `fan_speed`

Data type: `Integer`



### nvidia::xconfig

Note, only creates the configuration if GPUs are detected through a custom fact.
Also, after this change, the system will need to be rebooted.

